/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the ScriptMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ScriptMutable{}

// ScriptMutable struct for ScriptMutable
type ScriptMutable struct {
	Name *string `json:"name,omitempty"`
	MaxQuestions *int32 `json:"max_questions,omitempty"`
	Status *string `json:"status,omitempty"`
	RestartAllowed *bool `json:"restart_allowed,omitempty"`
	Locales []Locale `json:"locales,omitempty"`
	StartTrigger *StartTrigger `json:"start_trigger,omitempty"`
	StartCondition *Condition `json:"start_condition,omitempty"`
	Blocks []Block `json:"blocks,omitempty"`
	Assets []Asset `json:"assets,omitempty"`
	Formality *Formality `json:"formality,omitempty"`
}

// NewScriptMutable instantiates a new ScriptMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewScriptMutable() *ScriptMutable {
	this := ScriptMutable{}
	return &this
}

// NewScriptMutableWithDefaults instantiates a new ScriptMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewScriptMutableWithDefaults() *ScriptMutable {
	this := ScriptMutable{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *ScriptMutable) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptMutable) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *ScriptMutable) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *ScriptMutable) SetName(v string) {
	o.Name = &v
}

// GetMaxQuestions returns the MaxQuestions field value if set, zero value otherwise.
func (o *ScriptMutable) GetMaxQuestions() int32 {
	if o == nil || IsNil(o.MaxQuestions) {
		var ret int32
		return ret
	}
	return *o.MaxQuestions
}

// GetMaxQuestionsOk returns a tuple with the MaxQuestions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptMutable) GetMaxQuestionsOk() (*int32, bool) {
	if o == nil || IsNil(o.MaxQuestions) {
		return nil, false
	}
	return o.MaxQuestions, true
}

// HasMaxQuestions returns a boolean if a field has been set.
func (o *ScriptMutable) HasMaxQuestions() bool {
	if o != nil && !IsNil(o.MaxQuestions) {
		return true
	}

	return false
}

// SetMaxQuestions gets a reference to the given int32 and assigns it to the MaxQuestions field.
func (o *ScriptMutable) SetMaxQuestions(v int32) {
	o.MaxQuestions = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *ScriptMutable) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptMutable) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *ScriptMutable) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *ScriptMutable) SetStatus(v string) {
	o.Status = &v
}

// GetRestartAllowed returns the RestartAllowed field value if set, zero value otherwise.
func (o *ScriptMutable) GetRestartAllowed() bool {
	if o == nil || IsNil(o.RestartAllowed) {
		var ret bool
		return ret
	}
	return *o.RestartAllowed
}

// GetRestartAllowedOk returns a tuple with the RestartAllowed field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptMutable) GetRestartAllowedOk() (*bool, bool) {
	if o == nil || IsNil(o.RestartAllowed) {
		return nil, false
	}
	return o.RestartAllowed, true
}

// HasRestartAllowed returns a boolean if a field has been set.
func (o *ScriptMutable) HasRestartAllowed() bool {
	if o != nil && !IsNil(o.RestartAllowed) {
		return true
	}

	return false
}

// SetRestartAllowed gets a reference to the given bool and assigns it to the RestartAllowed field.
func (o *ScriptMutable) SetRestartAllowed(v bool) {
	o.RestartAllowed = &v
}

// GetLocales returns the Locales field value if set, zero value otherwise.
func (o *ScriptMutable) GetLocales() []Locale {
	if o == nil || IsNil(o.Locales) {
		var ret []Locale
		return ret
	}
	return o.Locales
}

// GetLocalesOk returns a tuple with the Locales field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptMutable) GetLocalesOk() ([]Locale, bool) {
	if o == nil || IsNil(o.Locales) {
		return nil, false
	}
	return o.Locales, true
}

// HasLocales returns a boolean if a field has been set.
func (o *ScriptMutable) HasLocales() bool {
	if o != nil && !IsNil(o.Locales) {
		return true
	}

	return false
}

// SetLocales gets a reference to the given []Locale and assigns it to the Locales field.
func (o *ScriptMutable) SetLocales(v []Locale) {
	o.Locales = v
}

// GetStartTrigger returns the StartTrigger field value if set, zero value otherwise.
func (o *ScriptMutable) GetStartTrigger() StartTrigger {
	if o == nil || IsNil(o.StartTrigger) {
		var ret StartTrigger
		return ret
	}
	return *o.StartTrigger
}

// GetStartTriggerOk returns a tuple with the StartTrigger field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptMutable) GetStartTriggerOk() (*StartTrigger, bool) {
	if o == nil || IsNil(o.StartTrigger) {
		return nil, false
	}
	return o.StartTrigger, true
}

// HasStartTrigger returns a boolean if a field has been set.
func (o *ScriptMutable) HasStartTrigger() bool {
	if o != nil && !IsNil(o.StartTrigger) {
		return true
	}

	return false
}

// SetStartTrigger gets a reference to the given StartTrigger and assigns it to the StartTrigger field.
func (o *ScriptMutable) SetStartTrigger(v StartTrigger) {
	o.StartTrigger = &v
}

// GetStartCondition returns the StartCondition field value if set, zero value otherwise.
func (o *ScriptMutable) GetStartCondition() Condition {
	if o == nil || IsNil(o.StartCondition) {
		var ret Condition
		return ret
	}
	return *o.StartCondition
}

// GetStartConditionOk returns a tuple with the StartCondition field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptMutable) GetStartConditionOk() (*Condition, bool) {
	if o == nil || IsNil(o.StartCondition) {
		return nil, false
	}
	return o.StartCondition, true
}

// HasStartCondition returns a boolean if a field has been set.
func (o *ScriptMutable) HasStartCondition() bool {
	if o != nil && !IsNil(o.StartCondition) {
		return true
	}

	return false
}

// SetStartCondition gets a reference to the given Condition and assigns it to the StartCondition field.
func (o *ScriptMutable) SetStartCondition(v Condition) {
	o.StartCondition = &v
}

// GetBlocks returns the Blocks field value if set, zero value otherwise.
func (o *ScriptMutable) GetBlocks() []Block {
	if o == nil || IsNil(o.Blocks) {
		var ret []Block
		return ret
	}
	return o.Blocks
}

// GetBlocksOk returns a tuple with the Blocks field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptMutable) GetBlocksOk() ([]Block, bool) {
	if o == nil || IsNil(o.Blocks) {
		return nil, false
	}
	return o.Blocks, true
}

// HasBlocks returns a boolean if a field has been set.
func (o *ScriptMutable) HasBlocks() bool {
	if o != nil && !IsNil(o.Blocks) {
		return true
	}

	return false
}

// SetBlocks gets a reference to the given []Block and assigns it to the Blocks field.
func (o *ScriptMutable) SetBlocks(v []Block) {
	o.Blocks = v
}

// GetAssets returns the Assets field value if set, zero value otherwise.
func (o *ScriptMutable) GetAssets() []Asset {
	if o == nil || IsNil(o.Assets) {
		var ret []Asset
		return ret
	}
	return o.Assets
}

// GetAssetsOk returns a tuple with the Assets field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptMutable) GetAssetsOk() ([]Asset, bool) {
	if o == nil || IsNil(o.Assets) {
		return nil, false
	}
	return o.Assets, true
}

// HasAssets returns a boolean if a field has been set.
func (o *ScriptMutable) HasAssets() bool {
	if o != nil && !IsNil(o.Assets) {
		return true
	}

	return false
}

// SetAssets gets a reference to the given []Asset and assigns it to the Assets field.
func (o *ScriptMutable) SetAssets(v []Asset) {
	o.Assets = v
}

// GetFormality returns the Formality field value if set, zero value otherwise.
func (o *ScriptMutable) GetFormality() Formality {
	if o == nil || IsNil(o.Formality) {
		var ret Formality
		return ret
	}
	return *o.Formality
}

// GetFormalityOk returns a tuple with the Formality field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptMutable) GetFormalityOk() (*Formality, bool) {
	if o == nil || IsNil(o.Formality) {
		return nil, false
	}
	return o.Formality, true
}

// HasFormality returns a boolean if a field has been set.
func (o *ScriptMutable) HasFormality() bool {
	if o != nil && !IsNil(o.Formality) {
		return true
	}

	return false
}

// SetFormality gets a reference to the given Formality and assigns it to the Formality field.
func (o *ScriptMutable) SetFormality(v Formality) {
	o.Formality = &v
}

func (o ScriptMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ScriptMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.MaxQuestions) {
		toSerialize["max_questions"] = o.MaxQuestions
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.RestartAllowed) {
		toSerialize["restart_allowed"] = o.RestartAllowed
	}
	if !IsNil(o.Locales) {
		toSerialize["locales"] = o.Locales
	}
	if !IsNil(o.StartTrigger) {
		toSerialize["start_trigger"] = o.StartTrigger
	}
	if !IsNil(o.StartCondition) {
		toSerialize["start_condition"] = o.StartCondition
	}
	if !IsNil(o.Blocks) {
		toSerialize["blocks"] = o.Blocks
	}
	if !IsNil(o.Assets) {
		toSerialize["assets"] = o.Assets
	}
	if !IsNil(o.Formality) {
		toSerialize["formality"] = o.Formality
	}
	return toSerialize, nil
}

type NullableScriptMutable struct {
	value *ScriptMutable
	isSet bool
}

func (v NullableScriptMutable) Get() *ScriptMutable {
	return v.value
}

func (v *NullableScriptMutable) Set(val *ScriptMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableScriptMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableScriptMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableScriptMutable(val *ScriptMutable) *NullableScriptMutable {
	return &NullableScriptMutable{value: val, isSet: true}
}

func (v NullableScriptMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableScriptMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


